package com.huimv.eco.service.impl;

import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huimv.eco.entity.SysHumidity;
import com.huimv.eco.entity.SysTemperature;
import com.huimv.eco.mapper.SysHumidityMapper;
import com.huimv.eco.mapper.SysTemperatureMapper;
import com.huimv.eco.service.ISysTemperatureService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author astupidcoder
 * @since 2021-11-11
 */
@Service
public class SysTemperatureServiceImpl extends ServiceImpl<SysTemperatureMapper, SysTemperature> implements ISysTemperatureService {
    @Autowired
    private SysTemperatureMapper temperatureMapper;
    @Override
    public List<SysTemperature> getList() {
        QueryWrapper<SysTemperature> wrapper = new QueryWrapper<>();
        wrapper.eq("farm_id",1);
        wrapper.ge("create_time", DateUtil.offsetMinute(new Date(),-30));
        return  temperatureMapper.getlist(wrapper);
    }
}
