package com.huimv.eco.timer;


import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.eco.entity.*;
import com.huimv.eco.service.*;
import org.apache.http.HttpEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.FileSystemResource;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.client.RestTemplate;

import java.util.Date;
import java.util.List;


@Component
public class SendTime {
    @Autowired
    private RestTemplate restTemplate;

    @Autowired
    private ISysHumidityService humidityService;

    @Autowired
    private ISysTemperatureService temperatureService;

    @Autowired
    private IBaseWarningInfoService baseWarningInfoService;

    @Autowired
    private ISysFodderService fodderService;

    @Autowired
    private ISysMonthWaterService monthWaterService;

    @Autowired
    private ISysDayWaterService dayWaterService;

//    String url = "http://127.0.0.1:8098/receiver/eco/save";
    String url = "http://120.27.234.126:8010/receiver/receiver/eco/save";



    @Scheduled(cron = "0 0/30 * * * ?")
//    @Scheduled(cron = "0 * * * * ?")
    private void sendTime(){

        DateTime dateTime = DateUtil.offsetMinute(new Date(), -30);
        HumAndTemDto humAndTemDto = new HumAndTemDto();

        //湿度
        List<SysHumidity> hum = humidityService.getlist();

        //温度
        List<SysTemperature> tem = temperatureService.getList();

        //报警
        QueryWrapper<BaseWarningInfo> warningInfoQueryWrapper = new QueryWrapper<>();
        warningInfoQueryWrapper.ge("warning_time",dateTime);
        List<BaseWarningInfo> warningInfos = baseWarningInfoService.list(warningInfoQueryWrapper);

        //料
        QueryWrapper<SysFodder> fodderWrapper = new QueryWrapper<>();
        fodderWrapper.ge("create_time",dateTime);
        List<SysFodder> fodders = fodderService.list(fodderWrapper);

        //月用水
        QueryWrapper<SysMonthWater> monthWaterWrapper = new QueryWrapper<>();
        monthWaterWrapper.ge("create_time",dateTime);
        List<SysMonthWater> monthWaters = monthWaterService.list(monthWaterWrapper);


        //月用水
        QueryWrapper<SysDayWater> dayWaterWrapper = new QueryWrapper<>();
        dayWaterWrapper.ge("create_time",dateTime);
        List<SysDayWater> dayWaters = dayWaterService.list(dayWaterWrapper);


        humAndTemDto.setHumidity(hum);
        humAndTemDto.setTemperature(tem);
        humAndTemDto.setWarningInfos(warningInfos);
        humAndTemDto.setFodders(fodders);
        humAndTemDto.setMonthWaters(monthWaters);
        humAndTemDto.setDayWaters(dayWaters);
        String s = restTemplate.postForObject(url, humAndTemDto, String.class);
        System.out.println(s);

    }



    @Scheduled(cron = "0 0 * * * ?")
//    @Scheduled(cron = "0 * * * * ?")
    private void sendTime1(){

        DateTime dateTime = DateUtil.offsetHour(new Date(), -1);
        HumAndTemDto humAndTemDto = new HumAndTemDto();


        //月用水
        QueryWrapper<SysMonthWater> monthWaterWrapper = new QueryWrapper<>();
        monthWaterWrapper.ge("create_time",dateTime);
        List<SysMonthWater> monthWaters = monthWaterService.list(monthWaterWrapper);


        //月用水
        QueryWrapper<SysDayWater> dayWaterWrapper = new QueryWrapper<>();
        dayWaterWrapper.ge("create_time",dateTime);
        List<SysDayWater> dayWaters = dayWaterService.list(dayWaterWrapper);

        humAndTemDto.setMonthWaters(monthWaters);
        humAndTemDto.setDayWaters(dayWaters);
        String s = restTemplate.postForObject(url, humAndTemDto, String.class);
        System.out.println(s);

    }
}