package com.huimv.huimvfarmnetip.task;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.huimv.huimvfarmnetip.utils.DateUtil;
import com.huimv.huimvfarmnetip.utils.HttpTemplete;
import com.huimv.huimvfarmnetip.utils.IPUtils;
import com.huimv.huimvfarmnetip.utils.TextUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.text.ParseException;
import java.util.HashMap;
import java.util.Map;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Slf4j
@Component
public class ScheduledService {
    @Autowired
    private IPUtils ipUtils;
    //发送每次称重服务
    @Value("${dataCenter.service.netIp}")
    private String updateNetIpService;
    //数据中心地址
    @Value("${dataCenter.ipAddr}")
    private String ipAddr;
    //数据中心地址
    @Value("${dataCenter.port}")
    private String port;
    //shellFile
    @Value("${local.shellFile}")
    private String shellFile;
    //farmID
    @Value("${local.farmID}")
    private String farmId;
    //relayPort
    @Value("${local.relay.port}")
    private String relayPort;
    @Autowired
    private HttpTemplete httpTemplete;
    @Autowired
    private TextUtil textUtil;
    @Autowired
    private DateUtil dateUtil;

    @Scheduled(cron = "0 */10 * * * ?")
    public void scheduled() throws UnsupportedEncodingException, ParseException {
//        log.info("=====>>>>>使用cron  {}",System.currentTimeMillis());
        String ip = ipUtils.run(shellFile).replace("\n","");
        JSONObject ipJo= new JSONObject();
        ipJo.put("farmId",farmId);
        ipJo.put("farmName","玉环牧场");
        ipJo.put("netIp",ip+relayPort);
        log.info(dateUtil.getTodayMissionText()+",发送数据>>"+ipJo.toJSONString());
        //发送数据
        _doPostSimple(updateNetIpService, textUtil.encode(ipJo.toJSONString()));
    }

    //发送简单数据
    private void _doPostSimple(String apiService, String data) {
        String url = ipAddr + port + apiService;
        log.info("推送数据地址：" + url);
        //
        Map<String, String> paramsMap = new HashMap<String, String>();
        paramsMap.put("data", data);
        //
        Map<String, Integer> timeoutMap = new HashMap<String, Integer>();
        timeoutMap.put("connectTimeout", 5000);
        timeoutMap.put("requestTimeout", 5000);
        timeoutMap.put("socketTimeout", 5000);
        try {
            // 用Post方法推送接口数据
            httpTemplete.doPost(url, paramsMap, timeoutMap);
        } catch (IOException e) {
            System.out.println("###错误信息：" + e.getMessage());
        }
    }
//    @Scheduled(fixedRate = 5000)
//    public void scheduled1() {
//        log.info("=====>>>>>使用fixedRate{}", System.currentTimeMillis());
//    }
//    @Scheduled(fixedDelay = 5000)
//    public void scheduled2() {
//        log.info("=====>>>>>fixedDelay{}",System.currentTimeMillis());
//    }
}
